"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var FrameLoop_1 = require("./FrameLoop");
var helpers_1 = require("./helpers");
exports.frameLoop = new FrameLoop_1.FrameLoop();
exports.now = function () { return Date.now(); };
exports.performanceNow = function () { return performance.now(); };
exports.colorNames = null;
exports.skipAnimation = false;
exports.getComponentProps = function (props) { return props; };
exports.createAnimatedStyle = null;
exports.createAnimatedTransform = null;
exports.requestAnimationFrame = typeof window !== 'undefined' ? window.requestAnimationFrame : function () { return -1; };
exports.cancelAnimationFrame = typeof window !== 'undefined' ? window.cancelAnimationFrame : helpers_1.noop;
exports.batchedUpdates = function (callback) { return callback(); };
exports.assign = function (globals) {
    var _a;
    return (_a = Object.assign({
        to: exports.to,
        now: exports.now,
        frameLoop: exports.frameLoop,
        colorNames: exports.colorNames,
        skipAnimation: exports.skipAnimation,
        defaultElement: exports.defaultElement,
        performanceNow: exports.performanceNow,
        getComponentProps: exports.getComponentProps,
        applyAnimatedValues: exports.applyAnimatedValues,
        createStringInterpolator: exports.createStringInterpolator,
        createAnimatedTransform: exports.createAnimatedTransform,
        createAnimatedStyle: exports.createAnimatedStyle,
        requestAnimationFrame: exports.requestAnimationFrame,
        cancelAnimationFrame: exports.cancelAnimationFrame,
        batchedUpdates: exports.batchedUpdates,
    }, pluckDefined(globals)), exports.to = _a.to, exports.now = _a.now, exports.frameLoop = _a.frameLoop, exports.colorNames = _a.colorNames, exports.skipAnimation = _a.skipAnimation, exports.defaultElement = _a.defaultElement, exports.performanceNow = _a.performanceNow, exports.getComponentProps = _a.getComponentProps, exports.applyAnimatedValues = _a.applyAnimatedValues, exports.createStringInterpolator = _a.createStringInterpolator, exports.createAnimatedTransform = _a.createAnimatedTransform, exports.createAnimatedStyle = _a.createAnimatedStyle, exports.requestAnimationFrame = _a.requestAnimationFrame, exports.cancelAnimationFrame = _a.cancelAnimationFrame, exports.batchedUpdates = _a.batchedUpdates, _a);
};
// Ignore undefined values
function pluckDefined(globals) {
    var defined = {};
    for (var key in globals) {
        if (globals[key] !== undefined)
            defined[key] = globals[key];
    }
    return defined;
}
//# sourceMappingURL=globals.js.map