import { FluidValue } from 'fluids';
/** Add the `FluidValue` type to every property */
export declare type FluidProps<T> = T extends object ? {
    [P in keyof T]: T[P] | FluidValue<T[P]>;
} : unknown;
/** These types can be animated */
export declare type Animatable<T = any> = T extends number ? number : T extends string ? string : T extends ReadonlyArray<number | string> ? Array<number | string> extends T ? ReadonlyArray<number | string> : {
    [P in keyof T]: Animatable<T[P]>;
} : never;
export interface FrameRequestCallback {
    (time?: number): void;
}
